select
  an.numero as numero_animal
  , s.nome as setor
  , idade.anos || ' ano(s) ' || idade.meses || ' ms(s) ' || idade.dias || ' dia(s)' as idade
  , an.dtnascimento as nascimento
  , an.dtdesmama as desmama
  , an.dtbaixa as abate
  , pri.data as primeira_reproducao
  , mae.numero as mae
  , pai.numero as pai
  , pnascimento.peso as peso_nascimento
  , (case
    when (pdesmama.dtpeso > an.dtdesmama) then pdesmama.peso - (pdesmama.gmd * (pdesmama.dtpeso - an.dtdesmama))
    when (pdesmama.dtpeso < an.dtdesmama) then pdesmama.peso + (pdesmama.gmd * (an.dtdesmama - pdesmama.dtpeso))
    when (pdesmama.dtpeso = an.dtdesmama) then pdesmama.peso
  else null end) as peso_desmama_real
  , pdesmama.dtpeso as dt_peso_desmama_real
  , (case
    when pdesmama.peso is not null and pnascimento.peso is not null and pdesmama.dtpeso <> pnascimento.dtpeso
      then ((pdesmama.peso - pnascimento.peso)/(pdesmama.dtpeso - pnascimento.dtpeso))
    else null end) as GMD_nascimento_desmama_real

  , (case
    when (p205.dtpeso > (an.dtnascimento + 205)) then (p205.peso - (p205.gmd * (p205.dtpeso - (an.dtnascimento + 205))))
    when (p205.dtpeso < (an.dtnascimento + 205)) then (p205.peso + (p205.gmd * ((an.dtnascimento + 205) - p205.dtpeso)))
    when (p205.dtpeso = (an.dtnascimento + 205)) then p205.peso
  else null end) as peso_205
  , p205.dtpeso as dt_peso_usado_205
  , (case
    when p205.peso is not null and pnascimento.peso is not null and p205.dtpeso <> pnascimento.dtpeso
      then ((p205.peso - pnascimento.peso)/(p205.dtpeso - pnascimento.dtpeso))
    else null end) as GMD_nascimento_205

  , psobreano.peso as peso_sobreano
  , psobreano.dtpeso as dt_peso_sobreano
  , (case
    when psobreano.peso is not null and pdesmama.peso is not null and psobreano.dtpeso <> pdesmama.dtpeso
      then ((psobreano.peso - pdesmama.peso)/(psobreano.dtpeso - pdesmama.dtpeso))
    else null end) as GMD_desmama_sobreano

  , (case
    when (p450.dtpeso > (an.dtnascimento + 450)) then (p450.peso - (p450.gmd * (p450.dtpeso - (an.dtnascimento + 450))))
    when (p450.dtpeso < (an.dtnascimento + 450)) then (p450.peso + (p450.gmd * ((an.dtnascimento + 450) - p450.dtpeso)))
    when (p450.dtpeso = (an.dtnascimento + 450)) then p450.peso
  else null end) as peso_450
  , p450.dtpeso as dt_peso_450
  , (case
    when p450.peso is not null and p205.peso is not null and p205.dtpeso <> p450.dtpeso
      then ((p450.peso - p205.peso)/(p450.dtpeso - p205.dtpeso))
    else null end) as GMD_205_450

  , pultimo.peso as ultimo_peso
  , pultimo.dtpeso as dt_ultimo_peso
  , (case
    when pultimo.peso is not null and psobreano.peso is not null and psobreano.dtpeso <> pultimo.dtpeso
      then ((pultimo.peso - psobreano.peso)/(pultimo.dtpeso - psobreano.dtpeso))
    else null end) as GMD_sobreano_ultimo

from animal an
  join setor s on s.cdsetor = an.cdsetor
  left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || AN.CDANIMAL) idade on 1=1
  left join reproducao pri on pri.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdanimal = an.cdanimal
    order by re.data asc)
  left join animal mae on mae.cdanimal = an.cdmae
  left join animal pai on pai.cdanimal = an.cdpai
  left join peso pnascimento on pnascimento.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = an.cdanimal
    order by re.dtpeso asc)
  left join peso pdesmama on pdesmama.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = an.cdanimal
      and re.dtpeso between (an.dtdesmama - 15) and (an.dtdesmama + 15)
    order by re.dtpeso desc)
  left join peso p205 on p205.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = an.cdanimal
      and re.dtpeso between (an.dtnascimento + 175) and (an.dtnascimento + 235)
    order by re.dtpeso desc)
  left join peso psobreano on psobreano.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = an.cdanimal
      and re.dtpeso between (an.dtnascimento + 340) and (an.dtnascimento + 670)
    order by re.dtpeso desc)
  left join peso p450 on p450.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = an.cdanimal
      and re.dtpeso between (an.dtnascimento + 340) and (an.dtnascimento + 670)
    order by re.dtpeso desc)
  left join peso pultimo on pultimo.cdpeso =
    (select first 1 re.cdpeso
    from peso re
    where re.cdanimal = an.cdanimal
    order by re.dtpeso desc)
where an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.cdanimal = 1862
